from Acquisition import aq_inner
from zope.component import getMultiAdapter
from zope import interface, schema, component
from z3c.form import form, field, button
from z3c.form.interfaces import INPUT_MODE

from plone.app.z3cform.layout import FormWrapper
from plone.app.batch.browser.interfaces import IBatchSearchForm
from plone.app.batch.browser.widgets import ContentTypesMultiCheckBoxWidgetFactory
from plone.app.batch.browser import baseform
from plone.app.batch import BatchMessageFactory as _

class BatchSearchBase(form.Form,baseform.BatchBaseForm):
    fields = field.Fields(IBatchSearchForm)
    fields['portal_type'].widgetFactory[INPUT_MODE] = ContentTypesMultiCheckBoxWidgetFactory
    ignoreContext = True

    @button.buttonAndHandler(_(u'Search'))
    def handleSearch(self, action):
        rform = self.request.form
        form_prefix = 'form.widgets.'
        def remove_prefix(key):
            if key.startswith(form_prefix):
                return key[len(form_prefix):]
            else:
                return key
        rform = dict([(remove_prefix(k),v) for k,v in rform.items()])
        context = aq_inner(self.context)
        configurations = self.getConfigurations()
        configurations['form'] = dict(rform)
        selector = getMultiAdapter((context,self.request),
                                    name=u'batch_selector_form')
        redirect_to = '%s/@@batch_selector_form' % context.absolute_url()
        self.request.response.redirect(redirect_to)

class BatchSearchForm(FormWrapper):
    form = BatchSearchBase
    label = _(u"Search form for batch editing")
