from Products.Five import zcml
from Products.Five import fiveconfigure

from Testing import ZopeTestCase as ztc

from Products.PloneTestCase import PloneTestCase as ptc
from Products.PloneTestCase.layer import onsetup

@onsetup
def setup_plone_app_batch():
    """Set up the additional products required for the plone_app_batch product.
    The @onsetup decorator causes the execution of this body to be deferred
    until the setup of the Plone site testing layer.
    """
    ztc.installProduct('Five')
    # Load the ZCML configuration for the plone.app.batch package.

    fiveconfigure.debug_mode = True
    import plone.app.batch
    zcml.load_config('configure.zcml', plone.app.batch)
    fiveconfigure.debug_mode = False

    # We need to tell the testing framework that these products
    # should be available. This can't happen until after we have loaded
    # the ZCML.

    ztc.installPackage('plone.app.batch')

# The order here is important: We first call the (deferred) function which
# installs the products we need for the plone_app_batch package. Then, we let
# PloneTestCase set up this product on installation.

setup_plone_app_batch()
ptc.setupPloneSite(products=['plone.app.batch'])

class PloneBatchTestCase(ptc.PloneTestCase):
    """Base class for plone.app.batch tests"""

class PloneBatchFunctionalTestCase(ptc.FunctionalTestCase):
    """Test case class used for functional (doc-)tests
    """

    class Session(dict):
        def set(self, key, value):
            self[key] = value

    def afterSetUp(self):
        super(PloneBatchFunctionalTestCase,self).afterSetUp()
        ztc.utils.setupCoreSessions(self.app)
        self.app.REQUEST['SESSION'] = self.Session()
