import unittest
from Testing import ZopeTestCase as ztc

from zope.testing import doctest
from Products.CMFCore.utils import getToolByName

from plone.app.batch.tests.base import PloneBatchTestCase
from plone.app.batch.tests.base import PloneBatchFunctionalTestCase

class TestSetup(PloneBatchTestCase):
    """Test product configurations after installed"""

    def test_content_action(self):
        batch_act_id = 'batchsearch'
        portal_actions = getToolByName(self.portal,'portal_actions')
        action_ids = [action.id for action in
                                            portal_actions.object.listActions()]
        self.failUnless(batch_act_id in action_ids,
                        '%s not in %s' % (batch_act_id,action_ids))

    def test_control_panel_action(self):
        batch_act_id = 'plone.app.batch'
        controlpanel = getToolByName(self.portal,'portal_controlpanel')
        action_ids = [action.id for action in controlpanel.listActions()]
        self.failUnless(batch_act_id in action_ids,
                        '%s not in %s' % (batch_act_id,action_ids))

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestSetup))
    suite.addTest(ztc.ZopeDocFileSuite(
                  'doc/setup.txt', package='plone.app.batch',
                  test_class=PloneBatchFunctionalTestCase,
                  optionflags=doctest.REPORT_ONLY_FIRST_FAILURE | doctest.NORMALIZE_WHITESPACE | doctest.ELLIPSIS),
                 )
    return suite
