from z3c.form.validator import SimpleFieldValidator
from zope.schema import ValidationError

import z3c.form.interfaces
import zope.interface
import zope.component

from plone.app.batch import BatchMessageFactory as _
from plone.app.batch.browser.interfaces import IBatchEditorSubForm
from plone.app.batch.interfaces import IBatchField

class ATValidation(ValidationError):
    doc_prefix = _(u"ATField validation failed. ")
    def __init__(self, message, value=None):
        ValidationError.__init__(self,message,value)
        self.message = message

    def doc(self):
        return self.doc_prefix + self.message

class BatchFieldValidator(SimpleFieldValidator):
    """Simple field validator for batch editing forms"""
    zope.interface.implements(z3c.form.interfaces.IValidator)
    zope.component.adapts(
    zope.interface.Interface,
    zope.interface.Interface,
    IBatchEditorSubForm,
    zope.schema.interfaces.IField,
    zope.interface.Interface)

    def validate(self, value):
        """See interfaces.IValidator"""
        if not IBatchField.providedBy(self.field):
            return super(BatchFieldValidator,self).validate(value)
        field = self.field
        if self.context is not None:
            atfield = self.context.schema[field.getName()]
            atvalidation = atfield.validate(value,self.context)
            if atvalidation is not None:
                raise ATValidation(str(atvalidation))
        return

